<template>
  <form class="d-flex flex-col" @submit="searchFor">
    <span>Age range:</span>
    <vue-slider v-model="age" :min="18" :max="80" :interval="1" :drag-on-click="true"></vue-slider>
    <span>Fame range:</span>
    <vue-slider v-model="fame" :min="0.0" :max="1.0" :interval="0.1" :drag-on-click="true"></vue-slider>
    <span>Max distance in km:</span>
    <vue-slider v-model="km_radius" :min="5" :max="250" :interval="5" :drag-on-click="true"></vue-slider>
    <span>Sort by:</span>
    <select class="w-100 mh-auto" v-model="sort">
      <option v-for="op of sortOptions" :key="op[0]"
      :value="op[1]">
      {{ op[0] }}
      </option>
    </select>
    <span class="mt-1">Filter interests:</span>
    <div class="d-flex flex-col flex-ai-start">
      <div v-for="i of user.interests" :key="i._id">
        <input type="checkbox" :id="`check-${i._id}`" v-model="interestFilters[i.name]">
        <label :for="`check-${i._id}`">{{ i.name }}</label>
      </div>
    </div>
    <br>
    <div class="d-flex flex-row">
      <button class="secondary flex-1 mr-1" type="button" @click="closeWindow">
        CANCEL
      </button>
      <AsyncButton class="primary flex-1 ml-1" :fn="searchFor">
        Search
      </AsyncButton>
    </div>
  </form>
</template>

<script>
import VueSlider from 'vue-slider-component';
import 'vue-slider-component/theme/antd.css';
import axios from 'axios';
import AsyncButton from '@/components/AsyncButton.vue';
import { mapState } from 'vuex';

export default {
  components: {
    VueSlider,
    AsyncButton
  },
  props: {
    show: {
      required: true,
      type: Boolean,
    },
  },
  data: () => ({
    age: [18, 80],
    fame: [0.5, 1.0],
    km_radius: 50,
    sort: '',

    interestFilters: {
    },

    sortOptions: [
      ['Distance', 'distance'],
      ['Common interests', 'commonInterests'],
      ['Fame', 'fame_rating'],
    ],
  }),
  computed: {
    ...mapState(['user']),
  },
  methods: {
    async searchFor (e) {
      e.preventDefault();

      let filters = null;
      for (const key of Object.keys(this.interestFilters)) {
        let f = this.user.interests.find((i) => i.name === key);
        if (!f) continue ;
        if (!filters) filters = { interests: { $all: [] } };
        filters.interests.$all.push(f._id);
      }

      try {
        let { data } = await axios.get('/api/user/match_feed', {
          params: {
            min_age: this.age[0],
            max_age: this.age[1],
            min_fame: this.fame[0],
            max_fame: this.fame[1],
            km_radius: this.km_radius,
            sort: this.sort,
            filters: filters || {},
          },
        });
        this.$bus.$emit('set-match', data || null);
        this.$emit('update:show', false);
      } catch(err) {
        if (err.response) {
          return alert(err.response.data.error);
        }
        else
          err;
      }
    },
    closeWindow (e) {
      e.preventDefault();
      this.$emit('update:show', false);
    }
  }
};
</script>
